#include<iostream>
#include<fstream>
#include<stdlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <sstream>
#include <vector>

#include <TROOT.h>
#include <TSystem.h>
#include <TEnv.h>
#include <TTree.h>
#include <TChain.h>
#include <TFile.h>
#include "TObject.h"
#include "TMath.h"
#include "TRandom.h"
#include "TThread.h"
#include "TChain.h"
#include "TProof.h"
#include "TProofLog.h"
#include "TProofMgr.h"
#include "TClonesArray.h"
#include "TH1D.h"




using namespace std;


void main()
{


  int Nevents=1000;

  gSystem->Load("delphes/libDelphes.so"); 

  // Create chain of root trees
  TChain chain("Delphes");


  TString dir = gSystem->UnixPathName(gInterpreter->GetCurrentMacroName());

   

    string name="data.in";
    ifstream myfile;
    myfile.open(name.c_str(), ios::in);
    if (!myfile) {
      cerr << "cannot find input file:  " << name << endl;
      exit(1);
    } else {
        cout << "-> Read data file=" << name << endl;
      }


  char * ffout="out/output.root";
  TFile RootFile(ffout, "RECREATE");



     string temp;
     while (myfile >> temp) {
           if (temp.find("#") == 0) continue;
           cout << ".. file to analyse=" << temp << endl;
           chain.Add(temp.c_str(),-1); // do not add non-recovebale
     }

  
  // Create object of class ExRootTreeReader
  ExRootTreeReader *treeReader = new ExRootTreeReader(&chain);
  Long64_t numberOfEntries = treeReader->GetEntries();
  
  // Get pointers to branches used in this analysis
  TClonesArray *branchJet = treeReader->UseBranch("Jet");
  
  // Book histograms
  TH1D *histJetPT = new TH1D("jet_pt", "jet P_{T}", 150, 0.0, 1500.0);
  TH1D *histN = new TH1D("numberN", "Number", 50, 0.0, 50.0);
  TH1D *histMass = new TH1D("jet_mass", "mass (4 GeV)", 90, 0.0, 360.0);


  Int_t nnev=0;

  // Loop over all events
  for(Int_t entry = 0; entry < numberOfEntries; ++entry)
  {
    // Load selected branches with data from specified event
    treeReader->ReadEntry(entry);

     if (nnev<=10 &&
       nnev<=100 && (nnev%10) == 0 ||
       nnev<=10000 && (nnev%1000) == 0  ||
       nnev>=10000 && (nnev%10000) == 0 ) {
          cout << "Events= " << nnev << endl; }
    if (nnev>Nevents) break;

    nnev++;

     if(branchJet->GetEntries() > 0)
    {

     int N=0;
     for(Int_t m= 0; m < branchJet->GetEntries(); ++m) {
      // Take first particle 
      Jet *jet = (Jet*) branchJet->At(m);
      float pt=jet->PT;
      float mass=jet->Mass;

      if (pt<800) continue;
        histJetPT->Fill(pt);
        histMass->Fill(mass); 
        N++;
      }
      histN->Fill(N);
    }

  }


  RootFile->Write();
  RootFile->Print();
  RootFile->Close();
  cout << "Output PROOF file=" << ffout << endl;





}
